/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.region.flags;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * TestblockMode defines where the Testblock should be inside a Region
 */
@Getter
@AllArgsConstructor
public enum TestblockMode implements Flag.Value<TestblockMode> {

    NO_VALUE("FLAG_TESTBLOCK_NO_VALUE", false),
    NORTH("FLAG_TESTBLOCK_NORTH", true),
    SOUTH("FLAG_TESTBLOCK_SOUTH", false);

    private static TestblockMode[] values;
    private final String chatValue;
    private final boolean north;

    @Override
    public TestblockMode[] getValues() {
        if (TestblockMode.values == null) {
            TestblockMode.values = TestblockMode.values();
        }
        return TestblockMode.values;
    }

    @Override
    public TestblockMode getValue() {
        return this;
    }

    @Override
    public TestblockMode getValueOf(final String name) {
        try {
            return TestblockMode.valueOf(name.toUpperCase());
        } catch (IllegalArgumentException e) {
            return NO_VALUE;
        }
    }
}